<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Namespace: d_1_handler</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Namespace: d_1_handler</h1>

    




<section>

<header>
    
        <h2>d_1_handler</h2>
        
    
</header>

<article>
    <div class="container-overview">
    
        
            <div class="description"><p>This namespace describes the function body of the mouse click callback function on
a calibration parameter in the function selection view.
<br>
The function body executes the following steps</p>
<li><a href="data.d_1_handler.html#.remove">1. delete all previous table rows (tr html elements) in the .table class</a></li>
<li><a href="data.d_1_handler.html#.JSON_parse">2. Convert postgres data format from JSON to JS and store it in local object</a></li>
<li><a href="data.d_1_handler.html#.insertHeadline">3. insert / create headline in .table class according to the currently clicked data element name.</a></li>
<li><a href="data.d_1_handler.html#.extractIndexColumn">3. Read index column from engine data</a></li>
<li><a href="data.d_1_handler.html#.insertRow">4. Insert all data into the data rows of the table</a></li>
<li><a href="data.d_1_handler.html#.colorIndexColumn">5. Color the index column (1st column) if data structure is a 3d map</a></li>
<li><a href="data.d_1_handler.html#.createFormattedTableData">6. Create formatted table data for potential storage</a></li>
<li><a href="data.d_1_handler.html#.createSetOfCurveStrc">7. Create configuration structure to convert data into a set of curves</a></li>
<li><a href="data.d_1_handler.html#.storeHTMLTblDatAsCurves">8. Store html table data as a set of curves in postgres</a></li>         
<b>Handling of 3d map objects</b><br>
If the name of the database object appears in a list of map names the object describes a 3d map. 
<br><br>
&nbsp;&nbsp;&nbsp;&nbsp; 8.2.2 Send variable 'outercollector' by emitting the socket.io event 'tabledata' to the server
<p></p></div>
        

        


<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line143">line 143</a>
    </li></ul></dd>
    

    

    

    
</dl>


        
    
    </div>

    

    

    

    

    

    

    
        <h3 class="subsection-title">Members</h3>

        
            
<h4 class="name" id=".comprObj"><span class="type-signature">(static) </span>comprObj<span class="type-signature"></span></h4>




<div class="description">
    <p>compressor : Instance of turbine object</p>
</div>







<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line481">line 481</a>
    </li></ul></dd>
    

    

    
    <dt class="tag-see">See:</dt>
    <dd class="tag-see">
        <ul>
            <li><a href="data.d_1_handler.html#.Compressor"><code>data.d_1_handler.Compressor</code></a></li>
        </ul>
    </dd>
    

    
</dl>






        
            
<h4 class="name" id=".headAr"><span class="type-signature">(static) </span>headAr<span class="type-signature"></span></h4>




<div class="description">
    <p>array of turbine &amp; compressor objects
<br>var headAr = [TurbineObj,comprObj];
<br><a href="data.d_1_handler.html#.Turbine"><code>Turbine Object</code></a><br>
<br><a href="data.d_1_handler.html#.Compressor"><code>Compressor Object</code></a></p>
</div>







<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line499">line 499</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id=".headline"><span class="type-signature">(static) </span>headline<span class="type-signature"></span></h4>




<div class="description">
    <p>all rows in the engine model cal. value table</p>
</div>







<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line780">line 780</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id=".nds"><span class="type-signature">(static) </span>nds<span class="type-signature"></span></h4>




<div class="description">
    <p>select all cells in the html data table</p>
</div>







<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line530">line 530</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id=".ndsData"><span class="type-signature">(static) </span>ndsData<span class="type-signature"></span></h4>




<div class="description">
    <p>all rows in the engine model cal. value table</p>
</div>







<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line730">line 730</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id=".TurbineObj"><span class="type-signature">(static) </span>TurbineObj<span class="type-signature"></span></h4>




<div class="description">
    <p>Instance of turbine object</p>
</div>







<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line452">line 452</a>
    </li></ul></dd>
    

    

    
    <dt class="tag-see">See:</dt>
    <dd class="tag-see">
        <ul>
            <li><a href="data.d_1_handler.html#.Turbine"><code>data.d_1_handler.Turbine</code></a></li>
        </ul>
    </dd>
    

    
</dl>






        
    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    
    <h4 class="name" id=".bufferColumnData"><span class="type-signature">(static) </span>bufferColumnData<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>The table data is loaded from the html table
and split into sets of curves. The sets of curves are
send to the server using a socket.io interface.
The server stores the data in postgres.<br>
<br>
Each row is devided in cells. The cells are organized
in columns of a row. Using the configured column position
of the trigger signal this function splits a new set of
curves by detecting a change in the trigger signal.<br>
On a changed trigger signal a databuffer in the curves
datastructure is set to an empty string. The string
is filled with each new row as long as the signal in the
trigger columns remains contant. <br>
On a change of the trigger signal the previously collected
data in the buffer is send to the server where the data
is stored in a postgres database before the buffer is freed
to receive new data for the next set of curves.</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line653">line 653</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id=".colorIndexColumn"><span class="type-signature">(static) </span>colorIndexColumn<span class="signature">(cmpString)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>Colors background of the index column darkblue.
This function is executed only if the the call parameter 'cmpString'
identifies the data element as a 3d data table. This is the case
if the function 'specialMap' returns true.
All row (tr) nodes of the table (according to class name 'table')
are selected. The d3 method 'select('td')' selects only the 1st
td / cell element in a row. Setting the background color
attribute 'bgcolor' to 'darkblue' colors the 1st column of
a row.</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>cmpString</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line331">line 331</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id=".createEmptyRowArrays"><span class="type-signature">(static) </span>createEmptyRowArrays<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>Initialize the databuffer field of the curves
data structure by pushing empty array into it for each signal
column according to the configured signal names.</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line563">line 563</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id=".createFormattedTableData"><span class="type-signature">(static) </span>createFormattedTableData<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>Merges all table data, including the index column
into one result vector. <br><br></p>
<p>Outer loop : All table row html elements (tr) of a 3d map are
read into a variable (tableHTML) as an array of html nodes <br><br>
Inner loop : the html 'div' elements of all cells of the current
table row are read into a nodes array. The data field of all div
nodes is pushed into an inner array 'innerCollector'. <br><br>
Outer loop (at return from inner loop) : push the innerCollector array
into the result vector, which is an array of 'innerCollector' arrays.
Foo object (@see: <code>module:handleModelData</code>)</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line364">line 364</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id=".createSetOfCurveStrc"><span class="type-signature">(static) </span>createSetOfCurveStrc<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>Creates and initializes a data structure for compressor and turbine
objects. This data structures are used to identify a set of curves
in a measurement dataset e.g. there is a triplet of measurement data where
the 1st element is constant thoughout one dataset. The transition from
one datset to the other is identified by the change of this 1st element.
If it changes, a new dataset starts. One curve in that set of curves would
be signal 2 over signal 3 or vice versa with a constant signal 1. <br><br></p>
<p>name : name of the dataset<br>
trig : name of the trigger signal i.e. the signal which is constant during set of curves
trigNo : column number of the trigger signal in the dataset
colNames : the element names of those elements which will be displayed in curves
colNmbrs : array of column numbers - each column number position corresponds to the element name and stands
for the column position of the data element in the data vector
databuf : contains the data for one set of curve e.g. in case of 4 signals and the first signal is the <br>
trigger signal this is a 3 x n vector with n : amount of samples</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line409">line 409</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id=".extractIndexColumn"><span class="type-signature">(static) </span>extractIndexColumn<span class="signature">(k, configArray, length, cmpString)</span><span class="type-signature"> &rarr; {Array.&lt;number>}</span></h4>
    

    



<div class="description">
    <p>The call parameter 'cmpString' contains the name of
the calibration data set which corresponds to the push button.
'cmpString' is compared to each name in the 'configArray' configuration
data structure. If a name in the configuration is equal to call parameter
an iteration across the data field of the configuration starts.
<br>
<br>
<a href="module-d_handleModelData_client.html#~configArray">Find <b>data</b> in the configuration array (click to find the configuration data field)</a>
<br><br>
<a href="module-d_handleModelData_client.html#~specialMap">If <b>data</b> represents a calibration map function specialMap returns 'true'</a>
<br><br>
If the data element stands for a calibration map the corresponding columns of the postgres table are pushed to an array named <b>collector</b>.</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>k</code></td>
            

            <td class="type">
            
                
<span class="param-type">obj</span>


            
            </td>

            

            

            <td class="description last"><p>iterator over postgres data</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>configArray</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array.&lt;object></span>


            
            </td>

            

            

            <td class="description last"><p>configuration array</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>length</code></td>
            

            <td class="type">
            
                
<span class="param-type">number</span>


            
            </td>

            

            

            <td class="description last"><p>handler function</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>cmpString</code></td>
            

            <td class="type">
            
                
<span class="param-type">number</span>


            
            </td>

            

            

            <td class="description last"><p>name of calling data object</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line256">line 256</a>
    </li></ul></dd>
    

    

    

    
</dl>















<h5>Returns:</h5>

        
<div class="param-desc">
    <p>3d map data in case of cmpString parameter
stands for a calibration map. Each row array stands for a column, each
element of a row array stands for a row element of the given column.</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Array.&lt;number></span>


    </dd>
</dl>

    





        
            

    

    
    <h4 class="name" id=".insertHeadline"><span class="type-signature">(static) </span>insertHeadline<span class="signature">(headline)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>Selects the table identified by its ID attribute 'table' and creates a caption
= headline of the table by filling the innerHTML object member of the caption element with
the headline string.</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>headline</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>headline text</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line173">line 173</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id=".insertRow"><span class="type-signature">(static) </span>insertRow<span class="signature">(collector, data)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>This function is called on the receipt of the engine configuration data
from postgres. It creates a table out of the header columns (collector) and the data of the postgres
engine parameters.<br><br> The function implements the following steps :</p>
<li>select the empty html table element according to the class identifier 'table'</li>
<li><b>outer loop = rows iterator</b> : iterate across all data elements plus one headline (this excludes the index column which is extracted before)</li>
<li>insert new row at the end of the table with each loop revolution</li>
<li><b>inner loop = columns iterator</b> : iterate across all column names</li>
<li><b>1st outer loop iteration (iterator equals zero)</b> : content = column names = collector array (call argument)</li>
<li><b>consecutive loop iterations</b> : content = data[outer loop iterator][inner loop iterator]</li>
<li><b>stop adding table element and break inner loop if content is empty</b></li>
<li>insert a new column cell into the row</li>
<li><b>Special case 1st row (outer loop iterator equals zero)</b>: set background color to darkblue</li>
<li>store content in innerHTML of new cell and make the cell content editable by setting the corresponding attribute</li>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>collector</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array.&lt;string></span>


            
            </td>

            

            

            <td class="description last"><p>column names / column headline numbers</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>data</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array.&lt;string></span>


            
            </td>

            

            

            <td class="description last"><p>array of table rows</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line194">line 194</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id=".JSON_parse"><span class="type-signature">(static) </span>JSON_parse<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>JSON_parse converts the JSON object into a Javascript object.</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line821">line 821</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id=".remove"><span class="type-signature">(static) </span>remove<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>deletes all rows of the html table element. <br>
There is one html table class with a potentially filled table. <br>
d3.select('.table') selects the one table class. <br>
d3.select('.table').selectAll('tr') selects all table rows in it<br>
d3.select('.table').selectAll('tr').remove() removes all table rows but
lets the surrounding table element untouched. <br></p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line807">line 807</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id=".sendCurveDataToServer"><span class="type-signature">(static) </span>sendCurveDataToServer<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>The table data is loaded from the html table
and split into sets of curves. The sets of curves are
send to the server using a socket.io interface.
The server stores the data in postgres.<br>
<br>
Each row is devided in cells. The cells are organized
in columns of a row. Using the configured column position
of the trigger signal this function splits a new set of
curves by detecting a change in the trigger signal.<br>
On a changed trigger signal a databuffer in the curves
datastructure is set to an empty string. The string
is filled with each new row as long as the signal in the
trigger columns remains contant. <br>
On a change of the trigger signal the previously collected
data in the buffer is send to the server where the data
is stored in a postgres database before the buffer is freed
to receive new data for the next set of curves.</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line702">line 702</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id=".specialMap"><span class="type-signature">(static) </span>specialMap<span class="signature">(cmpString)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>The function returns true if cmpString is equal to one of the following strings</p>
<li>EngineAmbientConditions</li>
<li>EngineEta</li>
<li>EngineFriction</li>
<li>EngineVolumEff</li>
<li>EngineRawParticulates</li>
<li>EngineRawNox</li>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>cmpString</code></td>
            

            <td class="type">
            
            </td>

            

            

            <td class="description last"><p>name of the data element which corresponds the clicked push button</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line304">line 304</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id=".storeDataOnChangeOfTrigger"><span class="type-signature">(static) </span>storeDataOnChangeOfTrigger<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>The table data is loaded from the html table
and split into sets of curves. The sets of curves are
send to the server using a socket.io interface.
The server stores the data in postgres.<br>
<br>
Each row is devided in cells. The cells are organized
in columns of a row. Using the configured column position
of the trigger signal this function splits a new set of
curves by detecting a change in the trigger signal.<br>
On a changed trigger signal a databuffer in the curves
datastructure is set to an empty string. The string
is filled with each new row as long as the signal in the
trigger columns remains contant. <br>
On a change of the trigger signal the previously collected
data in the buffer is send to the server where the data
is stored in a postgres database before the buffer is freed
to receive new data for the next set of curves.</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line584">line 584</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id=".storeHTMLTblDatAsCurves"><span class="type-signature">(static) </span>storeHTMLTblDatAsCurves<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>The table data is loaded from the html table
and split into sets of curves. The sets of curves are
send to the server using a socket.io interface.
The server stores the data in postgres.<br>
<br>
Each row is devided in cells. The cells are organized
in columns of a row. Using the configured column position
of the trigger signal this function splits a new set of
curves by detecting a change in the trigger signal.<br>
On a changed trigger signal a databuffer in the curves
datastructure is set to an empty string. The string
is filled with each new row as long as the signal in the
trigger columns remains contant. <br>
On a change of the trigger signal the previously collected
data in the buffer is send to the server where the data
is stored in a postgres database before the buffer is freed
to receive new data for the next set of curves.</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line750">line 750</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
    

    
        <h3 class="subsection-title">Type Definitions</h3>

        
                
<h4 class="name" id=".Compressor">Compressor</h4>




<div class="description">
    <p>Turbine object</p>
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">object</span>


        </li>
    </ul>





    <h5 class="subsection-title">Properties:</h5>

    

<table class="props">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>name</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>'EngineCompr' string identifier is used to find the correct dataset in the configuration</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>trig</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>'Ncor[rpm]' string identifier which describes the x-xis of the data multiple x-axis lead to multiple graphs</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>trigNo</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>0 integer ID that characterizes the number of the x axis</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>colNames</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>['WcompCor[kg/s]','PrComp[-]','EtaComp[-]'] y - value identifiers of the 2d graphs</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>colNmbrs[3</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array.&lt;number></span>


            
            </td>

            

            

            <td class="description last"><p>[0,0,0] initialization data</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>databuf</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array.&lt;number></span>


            
            </td>

            

            

            <td class="description last"><p>[] values - initialized as an empty array</p></td>
        </tr>

    
    </tbody>
</table>




<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line461">line 461</a>
    </li></ul></dd>
    

    

    

    
</dl>






            
                
<h4 class="name" id=".Turbine">Turbine</h4>




<div class="description">
    <p>Turbine object</p>
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">object</span>


        </li>
    </ul>





    <h5 class="subsection-title">Properties:</h5>

    

<table class="props">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>name</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>'EngineTurbine' string identifier is used to find the correct dataset in the configuration</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>trig</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>'ThVNT' string identifier which describes the x-xis of the data multiple x-axis lead to multiple graphs</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>trigNo</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>0 integer ID that characterizes the number of the x axis</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>colNames</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>['PrTurb','WTurbCor','EtaTurb'] y - value identifiers of the 2d graphs</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>colNmbrs[3</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array.&lt;number></span>


            
            </td>

            

            

            <td class="description last"><p>[0,0,0] initialization data</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>databuf</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array.&lt;number></span>


            
            </td>

            

            

            <td class="description last"><p>[] values - initialized as an empty array</p></td>
        </tr>

    
    </tbody>
</table>




<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line433">line 433</a>
    </li></ul></dd>
    

    

    

    
</dl>






            
    

    
        <h3 class="subsection-title">Events</h3>

        
            

    

    
    <h4 class="name" id=".event:curvedata">curvedata</h4>
    

    



<div class="description">
    <p><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata"><code>c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.event:curvedata</code></a></p>
</div>





    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">object</span>


        </li>
    </ul>









    <h5 class="subsection-title">Properties:</h5>

    

<table class="props">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>table</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>Indicates whether the snowball is tightly packed.</p></td>
        </tr>

    
    </tbody>
</table>




<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line624">line 624</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id=".event:initNewData">initNewData</h4>
    

    



<div class="description">
    <p>This event of the web client triggers a callback function on the server side
which prepares a new set of curves for editing and visualization.<br><br>Find the details
about the server sided event in the link <br>
<a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData"><code>server : start processing new curve data</code></a></p>
</div>





    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">object</span>


        </li>
    </ul>









<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line784">line 784</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id=".event:tabledata">tabledata</h4>
    

    



<div class="description">
    <p><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata"><code>c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.event:tabledata</code></a></p>
</div>





    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">object</span>


        </li>
    </ul>









    <h5 class="subsection-title">Properties:</h5>

    

<table class="props">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>table</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>Indicates whether the snowball is tightly packed.</p></td>
        </tr>

    
    </tbody>
</table>




<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_handleModelData.js.html">Script/handleModelData.js</a>, <a href="Script_handleModelData.js.html#line844">line 844</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
    
</article>

</section>




</div>

<nav>
    <h2><a href="index.html">Connected Controls Web App Docu</a></h2><h3>Modules</h3><ul><li><a href="module-a_index_server.html">a_index_server</a></li><li><a href="module-b_create_caldata_buttons_client.html">b_create_caldata_buttons_client</a></li><li><a href="module-c_socketCom_server.html">c_socketCom_server</a></li><li><a href="module-d_handleModelData_client.html">d_handleModelData_client</a></li><li><a href="module-e_getModelStimulationData_server.html">e_getModelStimulationData_server</a></li><li><a href="module-f_getPostgresData_server.html">f_getPostgresData_server</a></li><li><a href="module-g_setPostgresData_server.html">g_setPostgresData_server</a></li><li><a href="module-h_deletePostgresData_server.html">h_deletePostgresData_server</a></li><li><a href="module-i_getPostgresWOsocket_server.html">i_getPostgresWOsocket_server</a></li><li><a href="module-j_updatePostgresData_server.html">j_updatePostgresData_server</a></li><li><a href="module-k_select-stimulation_client.html">k_select-stimulation_client</a></li><li><a href="module-l_3d_map_visualization_client.html">l_3d_map_visualization_client</a></li><li><a href="module-m_curveGraphGenerator_client.html">m_curveGraphGenerator_client</a></li><li><a href="module-n_create_simulation_view_client.html">n_create_simulation_view_client</a></li><li><a href="module-o_3d_map_visualization_initialization_client.html">o_3d_map_visualization_initialization_client</a></li><li><a href="module-p_3d_map_table_generator.html">p_3d_map_table_generator</a></li></ul><h3>Namespaces</h3><ul><li><a href="audio.k_1_startStimulation.html">k_1_startStimulation</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html">b_1_dataviz</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames.html">b_1_1_getClassNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html">b_1_3_getAllButtonNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">b_1_4_thermdata_client</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html">c_1_socketfunction</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">c_1_1_socketConnected</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData.html">c_1_1_1_initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata.html">c_1_1_2_tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata.html">c_1_1_3_curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable.html">c_1_1_4_getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve.html">c_1_1_5_getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData.html">c_1_1_6_getStimData</a></li><li><a href="data.d_1_handler.html">d_1_handler</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html">m_1_curveGraphGenerator</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html">n_1_create_simulation_view</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html">n_1_1_rcvAudioFilePaths</a></li></ul><h3>Classes</h3><ul><li><a href="d3.html">d3</a></li><li><a href="express.html">express</a></li><li><a href="pool.html">pool</a></li><li><a href="response.html">response</a></li><li><a href="router.html">router</a></li><li><a href="selection.html">selection</a></li><li><a href="server.html">server</a></li><li><a href="socket.html">socket</a></li></ul><h3>Events</h3><ul><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html#.event:thermdata">thermdata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata">curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:disconnect">disconnect</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getCurve">getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getTable">getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData">initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata">tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:time">time</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html#.event:connection">connection</a></li><li><a href="data.d_1_handler.html#.event:curvedata">curvedata</a></li><li><a href="data.d_1_handler.html#.event:initNewData">initNewData</a></li><li><a href="data.d_1_handler.html#.event:tabledata">tabledata</a></li><li><a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:getCurve">getCurve</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:sendCurve">sendCurve</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:periodic_time">periodic_time</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html#.event:click_stimFileSelector">click_stimFileSelector</a></li></ul><h3>Tutorials</h3><ul><li><a href="tutorial-codeAnalysisAndRefactoring.html">Static source code analysis and refactoring interface</a></li><li><a href="tutorial-conceptUnitTest.html">conceptUnitTest</a></li><li><a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a></li><li><a href="tutorial-modelStimulation.html">Stimulation of physical and engine control models</a></li><li><a href="tutorial-staticEngineModel.html">Static combustion engine model</a></li><li><a href="tutorial-webclients.html">webclients</a></li></ul><h3>Global</h3><ul><li><a href="global.html#buildNav">buildNav</a></li><li><a href="global.html#publish">publish</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Sep 17 2021 09:09:23 GMT+0200 (Mitteleuropäische Sommerzeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>